<?php

class BoostMyShop_ErpCloud_Model_Sales_Order_Api extends Mage_Sales_Model_Order_Api
{

    /**
     * update shipping method in order
     *
     * @param $orderNumber
     * @param $methodCode
     */
    public function editShipmentMethod($orderNumber, $requestedMethodCode)
    {
        $order = Mage::getModel('sales/order')->load($orderNumber);
        if (!$order->getId())
            $this->_fault('Order does not exists');

        $magentoMethods = [];
        try
        {
            $methods = Mage::getSingleton('shipping/config')->getActiveCarriers();
            foreach ($methods as $shippingMethodCode => $shippingMethod){
                foreach($shippingMethod->getAllowedMethods() as $methodCode => $methodLabel)
                {
                    $label = Mage::getStoreConfig('carriers/'.$shippingMethodCode.'/title').' - '.$methodLabel;
                    $key = $shippingMethodCode.'_'.$methodCode;
                    $magentoMethods[$key] = $label;
                }
            }
        }
        catch(Exception $ex)
        {
            $this->_fault('Error:', $ex->getMessage());
        }
        if(isset($magentoMethods[$requestedMethodCode]))
        {
            try {
                $order->setshipping_method($requestedMethodCode)
                      ->setshipping_description($magentoMethods[$requestedMethodCode])
                      ->save();

            }catch (\Exception $ex){
                $this->_fault('Error:', $ex->getMessage());
            }
        }else{
            $this->_fault('Shipping method '.$methodCode.' not found');
        }
    }

}